<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html xmlns:th="https://www.thymeleaf.org">
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <!--<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">-->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
        <title>Hello, Codeworld!</title>
        <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14"></script>
        <script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk=" crossorigin="anonymous"></script>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.4/font/bootstrap-icons.css">
        <script src="https://cdn.jsdelivr.net/npm/busy-load@0.1.2/dist/app.min.js"></script>
        <link href="https://cdn.jsdelivr.net/npm/busy-load@0.1.2/dist/app.min.css" rel="stylesheet">
    </head>
    <body>
          
            <div class='container' id="app">
                <table class="table">
                    <thead>
                        <tr>
                            <th>Package</th>
                            <th>Name</th>
                            <th>Version</th>
                            <th>Description</th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="appEntry in appEntries">
                            <td>{{appEntry.packageName}}</td>
                            <td>{{appEntry.displayName}}</td>
                            <td>{{appEntry.version}}</td>
                            <td>{{appEntry.description}}</td>
                            <td>
                                <button class="btn btn-primary" v-on:click="execute(appEntry);">Execute</button>
                                <button class="btn btn-danger" v-on:click="uninstall(appEntry);">Uninstall</button>
                                <button class="btn btn-info process" v-on:click="showProcesses(appEntry);" v-if=" appEntry.hasProcess && !appEntry.done ">Show</button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <script th:inline="javascript">
                
                
            </script>
            <script>
                $.busyLoadSetup({animation: "slide", background: "rgba(127,63,191,0.54)"});

                function installJdk(version){
                    $.busyLoadFull("show", {text: "LOADING ...", textColor: "white", color: "#DCB5FF", textPosition: "bottom"});
                    $.ajax("/installJdk/version/"+version, {
                        success: function(d){
                            $.busyLoadFull("hide");
                            if(!d){
                                alert("fail to install jdk");
                            }else{
                                alert("jdk installed");
                            }
                        },
                        error: function(){
                            $.busyLoadFull("hide");
                            alert("fail to install jdk");
                        }
                    });
                }

                let app=new Vue({
                    el: "#app",
                    data:{
                        appEntries: []
                    },
                    methods:{
                        execute: function(appEntry){
                            $.busyLoadFull("show", {text: "LOADING ...", textColor: "white", color: "#DCB5FF", textPosition: "bottom"});
                            $.ajax("/run", {
                                type: "POST",
                                contentType: "application/json",
                                data: JSON.stringify(appEntry),
                                success: function(d){
                                    $.busyLoadFull("hide");
                                    if(d.error && d.statusCode==1){//the required jdk version is not found
                                        let ret=confirm("requested JDK version "+appEntry.jdkVersion+" not found, install (y/n)?");
                                        if(ret){
                                            installJdk(appEntry.jdkVersion);
                                        }
                                    }
                                },
                                error: function(){
                                    $.busyLoadFull("hide");
                                }
                            });   
                        },
                        uninstall: function(appEntry){
                            $.busyLoadFull("show", {text: "LOADING ...", textColor: "white", color: "#DCB5FF", textPosition: "bottom"});
                            $.ajax("/uninstall/packageName/"+appEntry.packageName+"/name/"+appEntry.name, {
                                type:"delete",
                                success: function(d){
                                    $.busyLoadFull("hide");
                                    window.location.reload();
                                },
                                error: function(){
                                    $.busyLoadFull("hide");
                                }
                            });
                        },
                        showProcesses: function(appEntry){
                            window.open("/showProcesses/packageName/"+appEntry.packageName+"/name/"+appEntry.name, "_blank");
                        }
                    }
                });
                $(document).ready(()=>{
                    $.busyLoadFull("show", {text: "LOADING ...", textColor: "white", color: "#DCB5FF", textPosition: "bottom"});
                    $.ajax('/apps/installed', {
                        success: function(d){
                            for(let t of d){
                                t.hasProcess=false;
                            }
                            app.appEntries=d;
                            $.busyLoadFull("hide");
                        },
                        error: function(){
                            $.busyLoadFull("hide");
                        }
                    });
                    
                    setInterval(()=>{
                        let map={};
                        $.ajax("/runTaskInfo", {
                            success: function(list){
                                for(let task of list){
                                    let app=task.processWrapper.appEntry;
                                    let key=app.packageName+"."+app.name;
                                    map[key]=task;
                                }
                                console.log(map);
                                for(let entry of app.appEntries){
                                    let key=entry.packageName+"."+entry.name;
                                    if(map[key]){
                                        console.log("found");
                                        entry.hasProcess=true;
                                    }else{
                                        entry.hasProcess=false;
                                    }
                                }
                            }
                        });
                    }, 10000);
                });
            </script>
    </body>
</html>
